/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.net.*;
import java.io.*;

public class DCCFrame extends Frame
{
    String dccnick,server;
    int port;
    Socket socket;
    InputStream in;
    Thread thread;
    
	public DCCFrame()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(486,466);
		setVisible(false);
		textArea1.setEditable(false);
		textArea1.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		add(textArea1);
		textArea1.setBackground(java.awt.Color.white);
		textArea1.setBounds(0,0,486,462);
		setTitle("{ڰ");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		//}}
	}

	public DCCFrame(String nk,String sv,String pt)
	{
		this();
		setTitle("DCC CHAT by " + nk);
		setVisible(true);
		dccnick = nk;
		long lsv = new Long(sv).longValue();
		long n1 = lsv >> 24 & 255;
		long n2 = lsv >> 16 & 255;
		long n3 = lsv >> 8 & 255;
		long n4 = lsv & 255;
		Long ln1 = new Long(n1),ln2 = new Long(n2),ln3 = new Long(n3),ln4 = new Long(n4);
		server = ln1.toString()+"."+ln2.toString()+"."+ln3.toString()+"."+ln4.toString();
		port = new Integer(pt).intValue();
		thread = new Thread(new Listen());
		thread.start();
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new DCCFrame()).setVisible(true);
	}
	
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.TextArea textArea1 = new java.awt.TextArea("",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
	//}}

	//{{DECLARE_MENUS
	//}}
	
	public void display(String s)
	{
	    textArea1.appendText(s +"\n");
	}
	
	String getLine()
    {
        byte buf[] = new byte[1024];
        byte b;
        int i = 0;
        String line = "";
        int c;
        while(true) {
            try {
                b = (byte)in.read();
                c = (char)b;
            } catch (IOException e) {
                line = null;
                break;
            }
            if (c == '\n' || c == '\r') {
                break;
            } else {
                buf[i++] = b;
                if (i >= 1024) {
                    break;
                }
            }
        }
        try {
            line = new String(buf, 0, i, "JIS");
        } catch (UnsupportedEncodingException e) {
            line = null;
        }
        return line;
    }
    
    class Listen implements Runnable
    {
        public void run()
        {
		    try {
		        try {
		            socket = new Socket(server,port);
		        } catch (UnknownHostException e) {
		            display("Cannot connect server.");
		            return;
		        }
		    } catch (IOException e2) {
		        display("Cannot create socket.");
		        return;
		    }
		    try {
		        in = socket.getInputStream();
	    	} catch (IOException e) {
	    	    display("Cannot create stream.");
	    	    return;
	    	}
	    	
		    while(true) {
		        String line = getLine();
		        if(line == null) {
		            display("Recieve error.");
		            return;
		        }
		        if(line.length() > 0) {
		            display("[" + dccnick + "] " + line);
		        }
		    }
        }
    }
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == DCCFrame.this)
				DCCFrame_WindowClosing(event);
		}
	}
	
	void DCCFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymComponent extends java.awt.event.ComponentAdapter
	{
		public void componentResized(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == DCCFrame.this)
				DCCFrame_ComponentResized(event);
		}
	}

	void DCCFrame_ComponentResized(java.awt.event.ComponentEvent event)
	{
		// to do: code goes here.
		Dimension Framesz = getSize();
		int Fx = 4,Fy = 24,Fx2 = Framesz.width-Fx-1,Fy2 = Framesz.height-Fy-1;
		textArea1.setBounds(Fx,Fy,Fx2,Fy2-18);
	}
}
